<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.streambase.StreamBase</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.streambase-module.html">Module&nbsp;streambase</a> ::
        Class&nbsp;StreamBase
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class StreamBase</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase">source&nbsp;code</a></span></p>
<pre class="base-tree">
<a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a> --+
                                  |
         <a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a> --+
                                  |
                                 <strong class="uidshort">StreamBase</strong>
</pre>

<dl><dt>Known Subclasses:</dt>
<dd>
      <ul class="subclass-list">
<li><a href="pyxmpp.stream.Stream-class.html">stream.Stream</a></li>  </ul>
</dd></dl>

<hr />
<p>Base class for a generic XMPP stream.</p>
<p>Responsible for establishing connection, parsing the stream, dispatching
received stanzas to apopriate handlers and sending application's stanzas.
This doesn't provide any authentication or encryption (both required by
the XMPP specification) and is not usable on its own.</p>
<p>Whenever we say &quot;stream&quot; here we actually mean two streams
(incoming and outgoing) of one connections, as defined by the XMPP
specification.</p>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">default_ns</span>,
        <span class="summary-sig-arg">extra_ns</span>=<span class="summary-sig-default"><code class="variable-group">(</code><code class="variable-group">)</code></span>,
        <span class="summary-sig-arg">keepalive</span>=<span class="summary-sig-default">0</span>,
        <span class="summary-sig-arg">owner</span>=<span class="summary-sig-default">None</span>)</span><br />
      Initialize Stream object</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_reset"></a><span class="summary-sig-name">_reset</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Reset <a href="pyxmpp.stream.Stream-class.html" class="link">Stream</a> object state making it ready to handle new
connections.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._reset">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__del__"></a><span class="summary-sig-name">__del__</span>(<span class="summary-sig-arg">self</span>)</span></td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.__del__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_connect_socket" class="summary-sig-name" onclick="show_private();">_connect_socket</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">sock</span>,
        <span class="summary-sig-arg">to</span>=<span class="summary-sig-default">None</span>)</span><br />
      Initialize stream on outgoing connection.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._connect_socket">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#connect" class="summary-sig-name">connect</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">addr</span>,
        <span class="summary-sig-arg">port</span>,
        <span class="summary-sig-arg">service</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">to</span>=<span class="summary-sig-default">None</span>)</span><br />
      Establish XMPP connection with given address.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_connect"></a><span class="summary-sig-name">_connect</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">addr</span>,
        <span class="summary-sig-arg">port</span>,
        <span class="summary-sig-arg">service</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">to</span>=<span class="summary-sig-default">None</span>)</span><br />
      Same as <code class="link">Stream.connect</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#accept" class="summary-sig-name">accept</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">sock</span>,
        <span class="summary-sig-arg">myname</span>)</span><br />
      Accept incoming connection.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.accept">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_accept"></a><span class="summary-sig-name">_accept</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">sock</span>,
        <span class="summary-sig-arg">myname</span>)</span><br />
      Same as <code class="link">Stream.accept</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._accept">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="disconnect"></a><span class="summary-sig-name">disconnect</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Gracefully close the connection.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.disconnect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_disconnect"></a><span class="summary-sig-name">_disconnect</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Same as <code class="link">Stream.disconnect</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._disconnect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_post_connect" class="summary-sig-name" onclick="show_private();">_post_connect</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Called when connection is established.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._post_connect">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_post_auth" class="summary-sig-name" onclick="show_private();">_post_auth</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Called when connection is authenticated.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._post_auth">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#state_change" class="summary-sig-name">state_change</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">state</span>,
        <span class="summary-sig-arg">arg</span>)</span><br />
      Called when connection state is changed.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.state_change">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="close"></a><span class="summary-sig-name">close</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Forcibly close the connection and clear the stream state.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.close">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_close"></a><span class="summary-sig-name">_close</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Same as <code class="link">Stream.close</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._close">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_make_reader"></a><span class="summary-sig-name">_make_reader</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Create ne <a href="pyxmpp.xmlextra.StreamReader-class.html" class="link">xmlextra.StreamReader</a> instace as <a href="pyxmpp.streambase.StreamBase-class.html#_reader" class="link" onclick="show_private();">self._reader</a>.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._make_reader">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#stream_start" class="summary-sig-name">stream_start</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">doc</span>)</span><br />
      Process &lt;stream:stream&gt; (stream start) tag received from peer.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stream_start">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#stream_end" class="summary-sig-name">stream_end</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">_unused</span>)</span><br />
      Process &lt;/stream:stream&gt; (stream end) tag received from peer.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stream_end">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#stanza_start" class="summary-sig-name">stanza_start</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">doc</span>,
        <span class="summary-sig-arg">node</span>)</span><br />
      Process stanza (first level child element of the stream) start tag
-- do nothing.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stanza_start">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#stanza" class="summary-sig-name">stanza</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">_unused</span>,
        <span class="summary-sig-arg">node</span>)</span><br />
      Process stanza (first level child element of the stream).</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stanza">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#error" class="summary-sig-name">error</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">descr</span>)</span><br />
      Handle stream XML parse error.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.error">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_send_stream_end"></a><span class="summary-sig-name">_send_stream_end</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Send stream end tag.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_end">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_send_stream_start"></a><span class="summary-sig-name">_send_stream_start</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">sid</span>=<span class="summary-sig-default">None</span>)</span><br />
      Send stream start tag.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_start">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_error" class="summary-sig-name" onclick="show_private();">_send_stream_error</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">condition</span>)</span><br />
      Send stream error element.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_error">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_restart_stream"></a><span class="summary-sig-name">_restart_stream</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Restart the stream as needed after SASL and StartTLS negotiation.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._restart_stream">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_make_stream_features" class="summary-sig-name" onclick="show_private();">_make_stream_features</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Create the &lt;features/&gt; element for the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._make_stream_features">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_send_stream_features" class="summary-sig-name" onclick="show_private();">_send_stream_features</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Send stream &lt;features/&gt;.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_features">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#write_raw" class="summary-sig-name">write_raw</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">data</span>)</span><br />
      Write raw data to the stream socket.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.write_raw">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_write_raw"></a><span class="summary-sig-name">_write_raw</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">data</span>)</span><br />
      Same as <code class="link">Stream.write_raw</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._write_raw">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_write_node" class="summary-sig-name" onclick="show_private();">_write_node</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>)</span><br />
      Write XML <code class="link">xmlnode</code> to the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._write_node">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#send" class="summary-sig-name">send</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Write stanza to the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.send">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_send"></a><span class="summary-sig-name">_send</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Same as <code class="link">Stream.send</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#idle" class="summary-sig-name">idle</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Do some housekeeping (cache expiration, timeout handling).</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.idle">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_idle"></a><span class="summary-sig-name">_idle</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Same as <code class="link">Stream.idle</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._idle">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="fileno"></a><span class="summary-sig-name">fileno</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Return filedescriptor of the stream socket.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.fileno">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="loop"></a><span class="summary-sig-name">loop</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">timeout</span>)</span><br />
      Simple &quot;main loop&quot; for the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.loop">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="loop_iter"></a><span class="summary-sig-name">loop_iter</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">timeout</span>)</span><br />
      Single iteration of a simple &quot;main loop&quot; for the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.loop_iter">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_loop_iter"></a><span class="summary-sig-name">_loop_iter</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">timeout</span>)</span><br />
      Same as <code class="link">Stream.loop_iter</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._loop_iter">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#process" class="summary-sig-name">process</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Process stream's pending events.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.process">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_process"></a><span class="summary-sig-name">_process</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Same as <code class="link">Stream.process</code> but assume <a href="pyxmpp.streambase.StreamBase-class.html#lock" class="link">self.lock</a> is acquired.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._process">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="_read"></a><span class="summary-sig-name">_read</span>(<span class="summary-sig-arg">self</span>)</span><br />
      Read data pending on the stream socket and pass it to the parser.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._read">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_feed_reader" class="summary-sig-name" onclick="show_private();">_feed_reader</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">data</span>)</span><br />
      Feed the stream reader with data received.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._feed_reader">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_process_node" class="summary-sig-name" onclick="show_private();">_process_node</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>)</span><br />
      Process first level element of the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._process_node">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_process_stream_node" class="summary-sig-name" onclick="show_private();">_process_stream_node</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>)</span><br />
      Process first level stream-namespaced element of the stream.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._process_stream_node">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#process_stream_error" class="summary-sig-name">process_stream_error</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">err</span>)</span><br />
      Process stream error element received.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.process_stream_error">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#check_to" class="summary-sig-name">check_to</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">to</span>)</span><br />
      Check &quot;to&quot; attribute of received stream header.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.check_to">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#generate_id" class="summary-sig-name">generate_id</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Generate a random and unique stream ID.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.generate_id">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_got_features" class="summary-sig-name" onclick="show_private();">_got_features</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Process incoming &lt;stream:features/&gt; element.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._got_features">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#bind" class="summary-sig-name">bind</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">resource</span>)</span><br />
      Bind to a resource.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.bind">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_bind_success" class="summary-sig-name" onclick="show_private();">_bind_success</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Handle resource binding success.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._bind_success">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#_bind_error" class="summary-sig-name" onclick="show_private();">_bind_error</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">stanza</span>)</span><br />
      Handle resource binding success.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._bind_error">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.streambase.StreamBase-class.html#connected" class="summary-sig-name">connected</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Check if stream is connected.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.connected">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a></code></b>:
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_in_stanza">fix_in_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#fix_out_stanza">fix_out_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_iq">process_iq</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_message">process_message</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_presence">process_presence</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_response">process_response</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#process_stanza">process_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#route_stanza">route_stanza</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_get_handler">set_iq_get_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_iq_set_handler">set_iq_set_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_message_handler">set_message_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_presence_handler">set_presence_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#set_response_handlers">set_response_handlers</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_get_handler">unset_iq_get_handler</a></code>,
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#unset_iq_set_handler">unset_iq_set_handler</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html">stanzaprocessor.StanzaProcessor</a></code></b> (private):
      <code><a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#_set_response_handlers" onclick="show_private();">_set_response_handlers</a></code>
      </p></div>
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a></code></b>:
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#warning">warning</a></code>
      </p>
    <div class="private">    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.xmlextra.StreamHandler-class.html">xmlextra.StreamHandler</a></code></b> (private):
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stanza" onclick="show_private();">_stanza</a></code>,
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stream_end" onclick="show_private();">_stream_end</a></code>,
      <code><a href="pyxmpp.xmlextra.StreamHandler-class.html#_stream_start" onclick="show_private();">_stream_start</a></code>
      </p></div>
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE VARIABLES ==================== -->
<a name="section-InstanceVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="_reader"></a><span class="summary-name">_reader</span><br />
      : the stream reader object (push parser) for the stream.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="features"></a><span class="summary-name">features</span><br />
      : stream features as annouced by the initiator.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="initiator"></a><span class="summary-name">initiator</span><br />
      : <code class="link">True</code> if local stream endpoint is the initiating entity.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="lock"></a><span class="summary-name">lock</span><br />
      : lock object used to synchronize access to the
<a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html" class="link">StanzaProcessor</a> object.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="me"></a><span class="summary-name">me</span><br />
      : local JID.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="owner"></a><span class="summary-name">owner</span><br />
      : <a href="pyxmpp.client.Client-class.html" class="link">Client</a>, <a href="pyxmpp.jabberd.component.Component-class.html" class="link">Component</a> or similar object &quot;owning&quot; this stream.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="peer"></a><span class="summary-name">peer</span><br />
      : remote stream endpoint JID.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="process_all_stanzas"></a><span class="summary-name">process_all_stanzas</span><br />
      : when <code class="link">True</code> then all stanzas received are
considered local.
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">default_ns</span>,
        <span class="sig-arg">extra_ns</span>=<span class="sig-default"><code class="variable-group">(</code><code class="variable-group">)</code></span>,
        <span class="sig-arg">keepalive</span>=<span class="sig-default">0</span>,
        <span class="sig-arg">owner</span>=<span class="sig-default">None</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.__init__">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize Stream object
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>default_ns</code></strong> - : stream's default namespace (&quot;jabber:client&quot; for
client, &quot;jabber:server&quot; for server, etc.)</li>
        <li><strong class="pname"><code>extra_ns</code></strong> - : sequence of extra namespace URIs to be defined for
the stream.</li>
        <li><strong class="pname"><code>keepalive</code></strong> - : keepalive output interval. 0 to disable.</li>
        <li><strong class="pname"><code>owner</code></strong> - : <a href="pyxmpp.client.Client-class.html" class="link">Client</a>, <a href="pyxmpp.jabberd.component.Component-class.html" class="link">Component</a> or similar object &quot;owning&quot; this stream.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#__init__">xmlextra.StreamHandler.__init__</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_connect_socket"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_connect_socket</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">sock</span>,
        <span class="sig-arg">to</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._connect_socket">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize stream on outgoing connection.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>sock</code></strong> - : connected socket for the stream</li>
        <li><strong class="pname"><code>to</code></strong> - : name of the remote host</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="connect"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">connect</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">addr</span>,
        <span class="sig-arg">port</span>,
        <span class="sig-arg">service</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">to</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.connect">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Establish XMPP connection with given address.</p>
<p>[initiating entity only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>addr</code></strong> - : peer name or IP address</li>
        <li><strong class="pname"><code>port</code></strong> - : port number to connect to</li>
        <li><strong class="pname"><code>service</code></strong> - : service name (to be resolved using SRV DNS records)</li>
        <li><strong class="pname"><code>to</code></strong> - : peer name if different than <code class="link">addr</code></li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="accept"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">accept</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">sock</span>,
        <span class="sig-arg">myname</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.accept">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Accept incoming connection.</p>
<p>[receiving entity only]</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>sock</code></strong> - : a listening socket.</li>
        <li><strong class="pname"><code>myname</code></strong> - : local stream endpoint name.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_post_connect"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_post_connect</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._post_connect">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Called when connection is established.</p>
<p>This method is supposed to be overriden in derived classes.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="_post_auth"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_post_auth</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._post_auth">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Called when connection is authenticated.</p>
<p>This method is supposed to be overriden in derived classes.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="state_change"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">state_change</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">state</span>,
        <span class="sig-arg">arg</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.state_change">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Called when connection state is changed.</p>
<p>This method is supposed to be overriden in derived classes
or replaced by an application.</p>
<p>It may be used to display the connection progress.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="stream_start"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">stream_start</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">doc</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stream_start">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process &lt;stream:stream&gt; (stream start) tag received from peer.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>doc</code></strong> - : document created by the parser</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#stream_start">xmlextra.StreamHandler.stream_start</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="stream_end"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">stream_end</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">_unused</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stream_end">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process &lt;/stream:stream&gt; (stream end) tag received from peer.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>_unused</code></strong> - : document created by the parser</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#stream_end">xmlextra.StreamHandler.stream_end</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="stanza_start"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">stanza_start</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">doc</span>,
        <span class="sig-arg">node</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stanza_start">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process stanza (first level child element of the stream) start tag
-- do nothing.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>doc</code></strong> - : parsed document</li>
        <li><strong class="pname"><code>node</code></strong> - : stanza's full XML</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="stanza"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">stanza</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">_unused</span>,
        <span class="sig-arg">node</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.stanza">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process stanza (first level child element of the stream).
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>_unused</code></strong> - : parsed document</li>
        <li><strong class="pname"><code>node</code></strong> - : stanza's full XML</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#stanza">xmlextra.StreamHandler.stanza</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="error"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">error</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">descr</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.error">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Handle stream XML parse error.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>descr</code></strong> - : error description</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.xmlextra.StreamHandler-class.html#error">xmlextra.StreamHandler.error</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="_send_stream_error"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_send_stream_error</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">condition</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_error">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Send stream error element.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>condition</code></strong> - : stream error condition name, as defined in the
XMPP specification.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_make_stream_features"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_make_stream_features</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._make_stream_features">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Create the &lt;features/&gt; element for the stream.</p>
<p>[receving entity only]</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>new &lt;features/&gt; element node.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_send_stream_features"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_send_stream_features</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._send_stream_features">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Send stream &lt;features/&gt;.</p>
<p>[receiving entity only]</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="write_raw"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">write_raw</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">data</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.write_raw">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Write raw data to the stream socket.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>data</code></strong> - : data to send</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_write_node"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_write_node</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._write_node">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Write XML <code class="link">xmlnode</code> to the stream.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> - : XML node to send.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="send"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">send</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.send">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Write stanza to the stream.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : XMPP stanza to send.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#send">stanzaprocessor.StanzaProcessor.send</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="idle"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">idle</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.idle">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Do some housekeeping (cache expiration, timeout handling).</p>
<p>This method should be called periodically from the application's
main loop.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="process"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.process">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process stream's pending events.</p>
<p>Should be called whenever there is input available
on <a href="pyxmpp.streambase.StreamBase-class.html#fileno" class="link">self.fileno()</a> socket descriptor. Is called by
<a href="pyxmpp.streambase.StreamBase-class.html#loop_iter" class="link">self.loop_iter</a>.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="_feed_reader"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_feed_reader</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">data</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._feed_reader">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Feed the stream reader with data received.</p>
<p>If <code class="link">data</code> is None or empty, then stream end (peer disconnected) is
assumed and the stream is closed.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>data</code></strong> (: <code class="link">unicode</code>) - : data received from the stream socket.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_process_node"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_process_node</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._process_node">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process first level element of the stream.</p>
<p>The element may be stream error or features, StartTLS
request/response, SASL request/response or a stanza.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> - : XML node describing the element</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_process_stream_node"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_process_stream_node</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._process_stream_node">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process first level stream-namespaced element of the stream.</p>
<p>The element may be stream error or stream features.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> - : XML node describing the element</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="process_stream_error"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">process_stream_error</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">err</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.process_stream_error">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Process stream error element received.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>err</code></strong> (: <a href="pyxmpp.error.StreamErrorNode-class.html" class="link">StreamErrorNode</a>) - : error received</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="check_to"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">check_to</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">to</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.check_to">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Check &quot;to&quot; attribute of received stream header.</p>
<p>Should be overriden in derived classes which require other logic
for handling that attribute.</p>
  <dl class="fields">
    <dt>Returns:</dt>
        <dd><code class="link">to</code> if it is equal to <a href="pyxmpp.streambase.StreamBase-class.html#me" class="link">self.me</a>, None otherwise.</dd>
    <dt>Overrides:
        <a href="pyxmpp.stanzaprocessor.StanzaProcessor-class.html#check_to">stanzaprocessor.StanzaProcessor.check_to</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="generate_id"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">generate_id</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.generate_id">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Generate a random and unique stream ID.
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>the id string generated.</dd>
  </dl>
</td></tr></table>
</div>
<a name="_got_features"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_got_features</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._got_features">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Process incoming &lt;stream:features/&gt; element.</p>
<p>[initiating entity only]</p>
<p>The received features node is available in <a href="pyxmpp.streambase.StreamBase-class.html#features" class="link">self.features</a>.</p>
  <dl class="fields">
  </dl>
</td></tr></table>
</div>
<a name="bind"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">bind</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">resource</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.bind">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Bind to a resource.</p>
<p>[initiating entity only]</p>
<p>XMPP stream is authenticated for bare JID only. To use
the full JID it must be bound to a resource.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>resource</code></strong> - : the resource name to bind to.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_bind_success"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_bind_success</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._bind_success">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Handle resource binding success.</p>
<p>[initiating entity only]</p>
<p>Set <a href="pyxmpp.streambase.StreamBase-class.html#me" class="link">self.me</a> to the full JID negotiated.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>stanza</code></strong> - : &lt;iq type=&quot;result&quot;/&gt; stanza received.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="_bind_error"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">_bind_error</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">stanza</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase._bind_error">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Handle resource binding success.</p>
<p>[initiating entity only]</p>
  <dl class="fields">
    <dt>Raises:</dt>
    <dd><ul class="nomargin-top">
        <li><code><strong class='fraise'><a href="pyxmpp.exceptions.FatalStreamError-class.html">FatalStreamError</a></strong></code></li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="connected"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">connected</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.streambase-pysrc.html#StreamBase.connected">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Check if stream is connected.
  <dl class="fields">
    <dt>Returns:</dt>
        <dd>True if stream connection is active.</dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:05 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
